"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (babel) {
  var t = babel.types;


  return {
    name: "ast-transform", // not required
    visitor: {
      CallExpression: function CallExpression(path, state) {
        var node = path.node;

        if (node.callee && node.callee.name == "aimport" && node.arguments[0]) {
          var variable_name = path.parent.id.name;
          var module_path = node.arguments[0].value;
          var async_module_name = "__async_" + variable_name;
          var async_module_path = "react-async-import!" + module_path;
          path.replaceWithSourceString("(()=>{\n                  const " + async_module_name + " = require('" + async_module_path + "');\n                  return require('react-async-import').bundle(" + async_module_name + ");\n\t\t\t\t  })()");
        }
      }
    }
  };
};

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
