import React from 'react';

export default function(babel) {
  const { types: t } = babel;

  return {
    name: "ast-transform", // not required
    visitor: {
      CallExpression(path, state){
        const { node } = path;
        if(node.callee && node.callee.name == "aimport" && node.arguments[0]){
         	 var variable_name = path.parent.id.name;
         	 var module_path = node.arguments[0].value;
        	 var async_module_name = "__async_" + variable_name;
        	 var async_module_path = "react-async-import!" + module_path;
        	 path.replaceWithSourceString(`(()=>{
                  const ${async_module_name} = require('${async_module_path}');
                  return require('react-async-import').bundle(${async_module_name});
				  })()`);
        }
      }
    }
  };
}
